﻿/*
 * Erstellt mit SharpDevelop.
 * Benutzer: Tornado
 * Datum: 22.05.2008
 * Zeit: 16:41
 * 
 * Sie können diese Vorlage unter Extras > Optionen > Codeerstellung > Standardheader ändern.
 */

using System;
using System.Collections.Generic;
using System.Drawing;
using System.Windows.Forms;
using Be.Windows.Forms;
using System.IO;

namespace HexCompare
{
    /// <summary>
    /// Description of MainForm.
    /// </summary>
    public partial class MainForm : Form
    {
        FileByteProvider file1, file2;
        Settings settings;
        public MainForm() {
            //
            // The InitializeComponent() call is required for Windows Forms designer support.
            //
            InitializeComponent();
            settings = new Settings(4, 5);
        }
       
        private void MainForm_SizeChanged(object sender, EventArgs e) {
            ResizeControls();
        }

        void loadFile(int box, string path) {
            if (box != 1 && box != 2) throw new ArgumentOutOfRangeException();
            if (!File.Exists(path)) throw new FileNotFoundException(path);

        }
        /// <summary>
        /// 
        /// </summary>
        /// <param name="threshold">Parts are recognized as equal if they have a length>=threshold</param>
        /// <param name="insertionThreshold">[Subject to change]If insertions are recognized which are longer than insertionThreshold, program tries first to search for changes first</param>
        void findDifferences(int threshold, int insertionThreshold) {
            //TODO: list some possible differences and choose best one, Progressbar
            
            lstDifferences.Items.Clear();
            if (file1.Length < threshold || file2.Length < threshold) {
                MessageBox.Show("One or both files are too short to compare!");
                return;
            }
            SpecialList list1 = new SpecialList(threshold);
            SpecialList list2 = new SpecialList(threshold);
            string path1 = file1.FileName;
            string path2 = file2.FileName;
            file1.Dispose();
            file2.Dispose();
            BinaryReader fileReader1 = new BinaryReader(new FileStream(path1, FileMode.Open));
            BinaryReader fileReader2 = new BinaryReader(new FileStream(path2, FileMode.Open));
            
          
            list1.AddRange(fileReader1.ReadBytes((int)fileReader1.BaseStream.Length));
            
            list2.AddRange(fileReader2.ReadBytes((int)fileReader1.BaseStream.Length));
            
            fileReader1.Close();
            fileReader2.Close();
            file1 = new FileByteProvider(path1);
            file2 = new FileByteProvider(path2);
            hexBox1.ByteProvider = file1;
            hexBox2.ByteProvider = file2;
            int differenceLength1, differenceLength2, lastPosition,differenceLengthBoth;

            
            while (!list1.EOL && !list2.EOL) {
                progressBar.Value = (int)(list1.Position / list1.Count * 100);

                if (list1.compareCurrentSnippet(list2)) {
                    if (!(list1.NextStep() && list2.NextStep()))
                        break;
                } else {
                    //Go to first difference:
                    while (!list1.compareCurrentSnippet(list2)) {
                        list1.Prev();
                        list2.Prev();
                    }
                    list1.NextStep();
                    list2.NextStep();
                    //Now the first byte of the actual snippet is the first difference
                    differenceLength1 = -1;
                    differenceLength2 = -1;
                    differenceLengthBoth=-1;

                    while ((differenceLength1 == -1 || differenceLength1 > insertionThreshold) && (differenceLength2 == -1 || differenceLength2 > insertionThreshold) && !list1.EOL && !list2.EOL) {
                        differenceLengthBoth++;
                        differenceLength1 = 0;
                        differenceLength2 = 0;

                        //look if something was inserted into file2
                        lastPosition = list2.Position;
                        while (!list2.EOL) {
                            if (list1.compareCurrentSnippet(list2)) break;
                            list2.Next();
                            differenceLength1++;
                        }
                        //If no analogy was found, list2 is at its end
                        if (list2.EOL) differenceLength1 = -1;
                        list2.Position = lastPosition;

                        //same thing for list1
                        lastPosition = list1.Position;
                        while (!list1.EOL) {
                            
                            if (list1.compareCurrentSnippet(list2)) break;
                            list1.Next();
                            differenceLength2++;
                            
                        }
                        if (list1.EOL) differenceLength2 = -1;
                        list1.Position = lastPosition;

                        //HACK:
                        if ((differenceLength1 == -1 || differenceLength1 > insertionThreshold) && (differenceLength2 == -1 || differenceLength2 > insertionThreshold)) {
                            list1.Next();
                            list2.Next();
                        }
                    }
                    
                    //no we are through, but found no more analogy -> the two files are different till the end
                    if (differenceLength1 == -1 && differenceLength2==-1) {
                        lstDifferences.Items.Add(new Difference(list1.Position - differenceLengthBoth, list2.Position - differenceLengthBoth, differenceLengthBoth, differenceLengthBoth));
                        //if the files are different till the end, we don't have to search for more analogies
                        break;
                    
                    //Something was inserted into file1 (as mentioned above)
                    }else if(differenceLength1==-1){
                        lstDifferences.Items.Add(new Difference(list1.Position - differenceLengthBoth, list2.Position - differenceLengthBoth, differenceLength2 + differenceLengthBoth, differenceLengthBoth));
                        //filepointer of file1 should be at the analogy
                        list1.Position += differenceLength2;
                    
                    //Same as above
                    } else if (differenceLength2==-1){
                        lstDifferences.Items.Add(new Difference(list1.Position - differenceLengthBoth, list2.Position - differenceLengthBoth, differenceLengthBoth, differenceLength1 + differenceLengthBoth));
                        list2.Position += differenceLength1;
                    //We found analogies if we tried to search for insertions in file1 and in file2 so perhaps a part of the file is repeated, we go on with the shorter difference
                    } else if (differenceLength2 < differenceLength1) {
                        lstDifferences.Items.Add(new Difference(list1.Position - differenceLengthBoth, list2.Position - differenceLengthBoth, differenceLength2 + differenceLengthBoth, differenceLengthBoth));
                        list1.Position += differenceLength2;
                    //Same as above
                    } else {
                        lstDifferences.Items.Add(new Difference(list1.Position - differenceLengthBoth, list2.Position - differenceLengthBoth, differenceLengthBoth, differenceLength1 + differenceLengthBoth));
                        list2.Position += differenceLength1;
                    }

                }
            }
            progressBar.Value = 0;
           
        }


        private void lstDifferences_DoubleClick(object sender, EventArgs e) {
            Difference selection=((Difference)lstDifferences.SelectedItem);
            hexBox1.Select(selection.position1, selection.differenceLength1);
            hexBox2.Select(selection.position2, selection.differenceLength2);
        }




        private void hexBox1_SelectionStartChanged(object sender, EventArgs e) {
            lblSelection1.Text = "Hex1: " + hexBox1.SelectionStart.ToString("X");
        }

        private void hexBox2_SelectionStartChanged(object sender, EventArgs e) {
            lblSelection2.Text = "Hex2: " + hexBox2.SelectionStart.ToString("X");
        }

        private void tbtnOptions_Click(object sender, EventArgs e) {
            new frmOptions(settings).Show(this);
        }

        private void comparisionWorker_ProgressChanged(object sender, System.ComponentModel.ProgressChangedEventArgs e) {
            progressBar.Value = e.ProgressPercentage;
        }

        private void comparisionWorker_DoWork(object sender, System.ComponentModel.DoWorkEventArgs e) {
            findDifferences(settings.Threshold, settings.Insertionthreshold);
        }


    }
    struct Difference
    {
        public Difference(int position1, int position2, int differenceLength1, int differenceLength2) {
            this.position1 = position1;
            this.position2 = position2;
            this.differenceLength1 = differenceLength1;
            this.differenceLength2 = differenceLength2;
        }

        public int position1;
        public int position2;
        public int differenceLength1;
        public int differenceLength2;
        public override string ToString() {
            return "Difference at " + position1.ToString("X") + "/" + position2.ToString("X")+" Difference Lengths: "+differenceLength1+"/"+differenceLength2;
        }
    }
}
