using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace HexCompare
{
    public partial class frmOptions : Form
    {
        Settings settings;
        public frmOptions(Settings settings) {
            InitializeComponent();
            toolTip.SetToolTip(lblThreshold, "Parts are recognized as equal if they have a length>=Threshold");
            toolTip.SetToolTip(txtThreshold, "Parts are recognized as equal if they have a length>=Threshold");
            toolTip.SetToolTip(lblInsertionThreshold, "If insertions are recognized which are longer than insertionThreshold, program tries first to search for changes first");
            toolTip.SetToolTip(txtInsertionThreshold, "If insertions are recognized which are longer than insertionThreshold, program tries first to search for changes first");
            this.settings = settings;
            LoadSettings();
        }
        public void LoadSettings() {
            txtThreshold.Value = settings.Threshold;
            txtInsertionThreshold.Value = settings.Insertionthreshold;
        }
        public void SaveSettings() {
            settings.Threshold = (int)txtThreshold.Value;
            settings.Insertionthreshold = (int)txtInsertionThreshold.Value;
        }

        private void btnSave_Click(object sender, EventArgs e) {
            SaveSettings();
        }

        private void btnRestore_Click(object sender, EventArgs e) {
            LoadSettings();
        }


    }
}