using System;
using System.Collections.Generic;
using System.Text;

namespace HexCompare
{
    class SpecialList
    {
        List<Byte> list = new List<byte>();
        int position;
        int threshold;
        public int Threshold
        {
            get { return threshold; }
        }
        public SpecialList(int threshold)
        {
            this.threshold = threshold;
        }
        public int Position
        {
            get { return position; }
            set { position = value>=0?value<Count?value:(int)Count:0; }
        }
        public long Count
        {
            get { return list.Count - threshold; }
        }
        public void Add(byte item)
        {
            list.Add(item);
        }
        byte[] getArray(int index)
        {
            if (index < 0) index = 0;
            if (index > (list.Count - threshold - 1)) index = list.Count - threshold - 1;
            byte[] array = new byte[threshold];
            for (int i = 0; i < threshold; i++)
                array[i] = list[index + i];
            return array;
        }
        public byte[] this[int index]
        {
            get { return getArray(index); }
        }
        public byte[] getCurrent()
        {
            return getArray(position);
        }
        public bool EOL
        {
            get { return position == Count; }
        }
        public bool NextStep()
        {
            if (position + threshold < Count)
            {
                Position+=threshold;
                return true;
            }else
            return Next();
        }
        public bool Next()
        {
            if (position  < Count)
            {
                Position++;
                return true;
            }
            return false;
        }
        public bool Prev()
        {
            if (position-1 > 0)
            {
                Position--;
                return true;
            }
            return false;
        }

        public bool compareCurrentSnippet(SpecialList list)
        {
            if (threshold != list.threshold) return false;
            byte[] temp1 = getArray(position);
            byte[] temp2 = list.getArray(list.position);
            for (int i = 0; i < threshold; i++)
                if (temp1[i] != temp2[i]) return false;
            return true;
        }

        public void AddRange(IEnumerable<byte> bytes) {
            list.AddRange(bytes);
        }
    }
}
